unit Unit1;

{$mode objfpc}{$H+}

interface

uses
  Classes, SysUtils, Forms, Controls, Graphics, Dialogs, StdCtrls;

type

  { TForm1 }

  TForm1 = class(TForm)
    Button1: TButton;
    Button2: TButton;
    Memo1: TMemo;
    procedure Button1Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
  private
    FSourceList: TStringList;

  public

  end;

var
  Form1: TForm1;

implementation

{$R *.lfm}

const
  WORDS: array[0..4] of string = (
    'MARY', 'JANE', 'LUCY', 'PAM', 'ALIX'
  );

{ TForm1 }

procedure TForm1.Button1Click(Sender: TObject);
const
  N = 1000*1000; //*1000;
var
  i: Integer;
  t: TDateTime;
begin
  t := Now;
  if FSourceList = nil then
    FSourceList := TStringList.Create
  else
    FSourceList.Clear;
  for i := 1 to N do
    FSourceList.Add(WORDS[Random(Length(WORDS))]);
  t := Now - t;
  Memo1.Lines.Add(Format('List with %d words created, duration %s s', [N, FormatDateTime('s.zzz', t)]));
end;

procedure TForm1.Button2Click(Sender: TObject);
var
  L: TStringList;
  i, j: integer;
  t: TDateTime;
begin
  t := Now;
  L := TStringList.Create;
  try
    L.Sorted := true;
    L.Duplicates := dupIgnore;
    for i := 0 to FSourceList.Count-1 do
      if L.Find(FSourceList[i], j) then
        L.Objects[j] := TObject(PtrInt(L.Objects[j]) + 1)
      else
        L.AddObject(FSourceList[i], TObject(PtrInt(1)));

    t := Now - t;
    Memo1.Lines.Add('These words were found, duration %s s', [FormatDateTime('s.zzz', t)]);;
    for i := 0 to L.Count-1 do
      Memo1.Lines.Add(Format('  "%s", %dx', [L[i], PtrInt(L.Objects[i])]));
  finally
    L.Free;
  end;

end;

end.

